\ Convert a blockfile to a regular text file
\
\ Usage:  BLK>FILE filename.fb
\ Output: filename.f
\
\ The result will be confusing and the parts that need LOAD
\ won't work right, but it's a start... :)

\ file-id's
VARIABLE SRC
VARIABLE DST

: BASENAME ( a1 u1 - a2 u2  Remove extension)
  SWAP OVER ( u a u)
  BEGIN 1- 2DUP + C@ [CHAR] . =  OVER 0=  OR UNTIL
  ?DUP IF  ROT DROP  ELSE  SWAP  THEN ;

: ADD-TXT ( a u - a2 u2  Add .txt extension)
  BASENAME  SWAP OVER PAD SWAP CMOVE ( u) >R
  S" .f" SWAP OVER ( u a u) PAD R@ + SWAP CMOVE
  R> + PAD SWAP ;

: BLK>FILE ( "blockfile" -)  BL PARSE 2DUP
  R/O BIN OPEN-FILE ABORT" Can't open input file" SRC !
  ADD-TXT  ." Saving as: " 2DUP TYPE CR
  R/W CREATE-FILE ABORT" Can't create output file" DST !
  BEGIN
    PAD 64 SRC @ READ-FILE ABORT" Read error"
    DUP  IF PAD 64 -TRAILING  DST @ WRITE-LINE
    ABORT" Write error"  THEN  0= UNTIL
  SRC @ CLOSE-FILE  DST @ CLOSE-FILE  2DROP ;
