\ uvars.f                                       18 Mar 2000  tcn

\ Memory map
HEX
  600 constant IDT
  E00 constant GDT
  F00 constant SVARS
 1000 constant KEYTBL   \ Keys-down table
 1100 constant KEYBUF   \ Keystroke buffer
 1200 constant CMDHIS   \ Command history buffer
 1600 constant SCRBUF   \ Scrollback buffer






\ System vars (SVARS) -- There's only one set of these
:' SVAR ( #SIZE "name" -)
  OVER CONSTANT + ;
SVARS ( Base address )
4 svar UVARS    \ Address of UVARS (including TSS)
DROP










\ User vars (UVARS) -- One set of UVARS for each process
:' UVAR ( #SIZE "name" -)
  OVER CONSTANT + ;
0 ( Base address )
\ 4 uvar KEYBUF   \ Keyboard buffer
4 uvar SCREEN   \ "Screen" object 
DROP

\ Words for accessing UVARS (only DWORD vars, for now)
\ Examples:  $B8000 VIDBUF UV!  and  VIDBUF UV@
\ (Write these in asm sometime...)
:' UV@ ( a - u)   UVARS @ + @ ;
:' UV! ( u a -)   UVARS @ + ! ;



\ SVARS are direct addresses, so you just use @ and !
\ Examples:  $102000 UVARS !  and  UVARS @














